﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class customProjects : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "CustomProjects",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastEditorPLangId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    UserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjects", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjects_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectDescriptions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectDescriptions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptions_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTests",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestSettingsId = table.Column<int>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTests", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_TestCaseSettingses_TestSettingsId",
                        column: x => x.TestSettingsId,
                        principalTable: "TestCaseSettingses",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestAssets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectTestAssets_CustomProjectTests_CustomProjectTestId",
                        column: x => x.CustomProjectTestId,
                        principalTable: "CustomProjectTests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectSolutions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    PLangId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectSolutions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutions_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutions_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectSolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectSolutionId = table.Column<int>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectSolutionFiles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutionFiles_CustomProjectSolutions_CustomProjectSolutionId",
                        column: x => x.CustomProjectSolutionId,
                        principalTable: "CustomProjectSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestWithSolutionAsTestResults",
                columns: table => new
                {
                    CustomProjectSolutionId = table.Column<int>(nullable: false),
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestWithSolutionAsTestResults", x => new { x.CustomProjectSolutionId, x.CustomProjectTestId });
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithSolutionAsTestResults_CustomProjectSolutions_CustomProjectSolutionId",
                        column: x => x.CustomProjectSolutionId,
                        principalTable: "CustomProjectSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithSolutionAsTestResults_CustomProjectTests_CustomProjectTestId",
                        column: x => x.CustomProjectTestId,
                        principalTable: "CustomProjectTests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.AddColumn<int>(
                name: "MaxCustomProjectsPerUser",
                table: "SystemSettings",
                nullable: false,
                defaultValue: 10);

            migrationBuilder.AddColumn<int>(
                name: "CustomProjectDescriptionId",
                table: "Assets",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_Assets_CustomProjectDescriptionId",
                table: "Assets",
                column: "CustomProjectDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjects_UserId",
                table: "CustomProjects",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptions_CustomProjectId",
                table: "CustomProjectDescriptions",
                column: "CustomProjectId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_CustomProjectId",
                table: "CustomProjectSolutions",
                column: "CustomProjectId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_MainFileId",
                table: "CustomProjectSolutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_PLangId",
                table: "CustomProjectSolutions",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutionFiles_CustomProjectSolutionId",
                table: "CustomProjectSolutionFiles",
                column: "CustomProjectSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_CustomProjectId",
                table: "CustomProjectTests",
                column: "CustomProjectId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_TestSettingsId",
                table: "CustomProjectTests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_TestTypeId",
                table: "CustomProjectTests",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestAssets_CustomProjectTestId",
                table: "CustomProjectTestAssets",
                column: "CustomProjectTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithSolutionAsTestResults_CustomProjectSolutionId",
                table: "CustomProjectTestWithSolutionAsTestResults",
                column: "CustomProjectSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithSolutionAsTestResults_CustomProjectTestId",
                table: "CustomProjectTestWithSolutionAsTestResults",
                column: "CustomProjectTestId");

            migrationBuilder.AddForeignKey(
                name: "FK_Assets_CustomProjectDescriptions_CustomProjectDescriptionId",
                table: "Assets",
                column: "CustomProjectDescriptionId",
                principalTable: "CustomProjectDescriptions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjectSolutionFiles_MainFileId",
                table: "CustomProjectSolutions",
                column: "MainFileId",
                principalTable: "CustomProjectSolutionFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Assets_CustomProjectDescriptions_CustomProjectDescriptionId",
                table: "Assets");

            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjects_CustomProjectId",
                table: "CustomProjectSolutions");

            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjectSolutionFiles_MainFileId",
                table: "CustomProjectSolutions");

            migrationBuilder.DropIndex(
                name: "IX_Assets_CustomProjectDescriptionId",
                table: "Assets");

            migrationBuilder.DropColumn(
                name: "MaxCustomProjectsPerUser",
                table: "SystemSettings");

            migrationBuilder.DropColumn(
                name: "CustomProjectDescriptionId",
                table: "Assets");

            migrationBuilder.DropTable(
                name: "CustomProjectDescriptions");

            migrationBuilder.DropTable(
                name: "CustomProjectTestAssets");

            migrationBuilder.DropTable(
                name: "CustomProjectTestWithSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "CustomProjectTests");

            migrationBuilder.DropTable(
                name: "CustomProjects");

            migrationBuilder.DropTable(
                name: "CustomProjectSolutionFiles");

            migrationBuilder.DropTable(
                name: "CustomProjectSolutions");
        }
    }
}
