﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using ClientServer.Db;

namespace ClientServer.Models.Exercises
{
    /// <summary>
    /// a tag (e.g. a keyword or a category)
    /// </summary>
    public class Tag
    {

        public Tag()
        {
            //TagWithMetaDatas = new List<TagWithMetaData>();
        }

        public int Id { get; set; }

        /// <summary>
        /// the name
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string DisplayName { get; set; }


        /// <summary>
        /// the some description text (for popup)
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string Description { get; set; }
        /// <summary>
        /// the html color (css string)
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string HtmlColor { get; set; }

        /// <summary>
        /// the html background color (css string)
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string HtmlBackgroundColor { get; set; }

        /// <summary>
        /// the html icon string
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string HtmlIcon { get; set; }

    }
}
