﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using ClientServer.Db;
using ClientServer.Models.Interfaces;

namespace ClientServer.Models.Exercises.Tests
{
    /// <summary>
    /// default settings for the tests the users create (user should not set the settings...)
    /// </summary>
    public class DefaultCustomTestSettings : ITestSettings
    {
        public int Id { get; set; }
        /// <summary>
        /// the timeout in ms
        /// </summary>
        public int TimeoutInMs { get; set; }

        /// <summary>
        /// the compile timeout in ms
        /// </summary>
        public int CompileTimeoutInMs { get; set; }
        
        /// <summary>
        /// the max amount of ram in mb for the <see cref="Test"/>
        /// </summary>
        public int MemoryLimitInKb { get; set; }

        /// <summary>
        /// the max amount of disk space the <see cref="Test"/> can write to
        /// </summary>
        public int MaxDiskSpaceInKb { get; set; }
        
        /// <summary>
        /// some compiler options .g. -Xlint options needs to be separated by whitespaces (like normal command args)
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string CompilerOptions { get; set; }


        public int ExerciseId { get; set; }
        /// <summary>
        /// the connected <see cref="Exercise"/>
        /// </summary>
        public Exercise Exercise { get; set; }
    }
}
